var lineWidth3D = 0.5;

function set3DLineWidth(w)
{
	lineWidth3D = w;
}

function draw3DPoint(v)
{
	var x = v.x-camPos.x;
	var y = v.y-camPos.y;
	var z = v.z-camPos.z;

	if(z <= 0)return;
	if(z >= maxDistance)return;

	var d = z;

	var r = getRed();
	var g = getGreen();
	var b = getBlue();

	setColor(r*5/d,g*5/d,b*5/d);

	setLineWidth(lineWidth3D/d);
	drawPoint(x/d,y/d);

	setColor(r,g,b);
}

function draw3DLine(v1,v2)
{
	var x1 = v1.x-camPos.x;
	var y1 = v1.y-camPos.y;
	var z1 = v1.z-camPos.z;
	var x2 = v2.x-camPos.x;
	var y2 = v2.y-camPos.y;
	var z2 = v2.z-camPos.z;

	if(z1 <= 0)return;
	if(z2 <= 0)return;
	if(z1 >= maxDistance)return;
	if(z2 >= maxDistance)return;

	var d1 = z1;
	var d2 = z2;

	var d = d2;
	if(d2 < d1){
		d = d1;
	}

	var r = getRed();
	var g = getGreen();
	var b = getBlue();

	setColor(r*5/d,g*5/d,b*5/d);

	setLineWidth(lineWidth3D/d);
	drawLine(x1/d1,y1/d1,x2/d2,y2/d2);

	setColor(r,g,b);
}

var readyString = "RRRR    EEEEE    AAA    DDDD    Y   Y\
R   R   E       A   A   D   D    Y Y \
RRRR    EEE     AAAAA   D   D     Y  \
R   R   E       A   A   D   D     Y  \
R   R   EEEEE   A   A   DDDD      Y  ";

var oopsString = " OOO     OOO    PPPP     SSSS     !  \
O   O   O   O   P   P   S         !  \
O   O   O   O   PPPP     SSS      !  \
O   O   O   O   P           S        \
 OOO     OOO    P       SSSS      !  ";

var readyString = "RRRR    EEEEE    AAA    DDDD    Y   Y\
R   R   E       A   A   D   D    Y Y \
RRRR    EEE     AAAAA   D   D     Y  \
R   R   E       A   A   D   D     Y  \
R   R   EEEEE   A   A   DDDD      Y  ";

var oopsString = " OOO     OOO    PPPP     SSSS     !  \
O   O   O   O   P   P   S         !  \
O   O   O   O   PPPP     SSS      !  \
O   O   O   O   P           S        \
 OOO     OOO    P       SSSS      !  ";

var gameString = "     GGG     AAA    M   M   EEEEE    \
    G       A   A   MM MM   E        \
    G  GG   AAAAA   M M M   EEE      \
    G   G   A   A   M   M   E        \
     GGG    A   A   M   M   EEEEE    "

var overString = "     OOO    V   V   EEEEE   RRRR     \
    O   O   V   V   E       R   R    \
    O   O    V V    EEE     RRRR     \
    O   O    V V    E       R   R    \
     OOO      V     EEEEE   R   R    "

var string = new Array();

string["1"] = "  1  \
 11  \
  1  \
  1  \
 111 "

string["2"] = " 222 \
2   2\
  22 \
22   \
22222";

string["3"] = "33333\
    3\
 333 \
    3\
3333 ";

string["4"] = "4  4 \
4  4 \
44444\
   4 \
   4 ";

string["5"] = "55555\
5    \
5555 \
    5\
5555 ";

string["6"] = " 666 \
6    \
6666 \
6   6\
 666 ";

string["7"] = "77777\
   7 \
   7 \
  7  \
  7  ";

string["8"] = " 888 \
8   8\
 888 \
8   8\
 888 ";

string["9"] = " 999 \
9   9\
 9999\
    9\
 999 ";

string["0"] = " 000 \
0   0\
0   0\
0   0\
 000 ";

function drawNumber(number,time)
{
	setLineWidth(0.05);
	var ndigits = Math.floor(Math.log(Math.abs(number))/Math.log(10))+1;

	var hw = Math.floor((ndigits*8-3)/2);

	var n = ""+number;

	for(var i=0;i<ndigits;i++){
		for(var x=0;x<5;x++)
		{
			for(var y=0;y<5;y++)
			{
				if(string[n.charAt(i)].charAt(y*5+x) != ' ')
				{
					drawPoint((x+i*8-hw)/37,-(y-2)/(50-4*(time)*(time)));
				}
			}
		}
	}
}

function drawStr(str,time)
{
	setLineWidth(0.05);
	for(var x=0;x<37;x++)
	{
		for(var y=0;y<5;y++)
		{
			if(str.charAt(y*37+x) != ' ')
			{
				drawPoint((x-18)/37,-(y-2)/(50-4*(time)*(time)));
			}
		}
	}
}

function drawPortal(pos,time)
{
	setColor(0.25,0.5,1);
	set3DLineWidth(1);
	draw3DPoint(new Vector(0,0.5,pos));
	set3DLineWidth(0.5);
	draw3DPoint(new Vector(0,0.5,pos));
	for(var i=0;i<6;i++){
		var d = 2*Math.PI/6*i+time;
		draw3DPoint(new Vector(Math.sin(d)/4,Math.cos(d)/4+0.5,pos));
		draw3DPoint(new Vector(Math.sin(-d)/8,Math.cos(-d)/8+0.5,pos));
	}
}

function draw()
{
	setColor(1,1,1);
	switch(gameState)
	{
	case gameState_ready:
		setColor(3-gameTime/1.5,0,0);
		drawStr(readyString,gameTime/1.5);
	case gameState_levelNum:
		if(gameState != gameState_ready){
			drawNumber(level,Math.sin(gameTime)+1);
		}
	case gameState_fall:
	case gameState_portal:
	case gameState_gameOver:
	case gameState_play:
		levelData.draw();

		if(gameState != gameState_portal){
			// Draw the player.
			set3DLineWidth(0.5);
			if(playerPos.y>=0){
				setColor(0,1,0);
			}else{
				var c = 2+playerPos.y;
				setColor(0,c,0);
			}
			draw3DPoint(playerPos);
		}

		if(gameState == gameState_gameOver){
			setColor((Math.cos(gameTime/3)+1)/2,0,0);
			drawStr(gameString,0);
			setColor((-Math.cos(gameTime/3)+1)/2,0,0);
			drawStr(overString,0);
		}

		break;
	case gameState_goBack:

		levelData.draw();

		// Draw the player.
		set3DLineWidth(0.5);
		//setColor(gameTime/2,gameTime/2,gameTime/2);
		setColor(0,gameTime/2,0);
		draw3DPoint(playerPos);

		break;
	}

	if(gameState == gameState_fall){
		setColor(gameTime/1.5,gameTime/1.5,0);
		drawStr(oopsString,0);
	}

	setLineWidth(0.125);
	setColor(0,1,0);
	for(var i=0;i<lives;i++){
		drawPoint((i/10)-0.9,-screenHeight/screenWidth+0.1);
	}
}