var seed = 0;

var seedMax = 831.459;

function srand(s){
	seed = Math.pow(s+2.35831,23.5831)%seedMax;
}

function rand(){
	srand(seed);
	return seed/seedMax;
}

function rrand(min,max){
	return rand()*(max-min)+min;
}

function irand(min,max){
	return Math.floor(rand()*(max-min)+min);
}

function brand(p){
	if(rand() <= p){
		return true;
	}
	return false;
}

/*
level length:		100	...	300
end track length:	15	...	10
track length:		15	...	2.5
track type:		single	ring	invring	double
blank %			0.25	...	0.9

obs dist:		6	...	1
obs dist:		.75	...	.9
blank length:		1	1.25
*/

var hL = 5;

var levelLen_e = 50;
var levelLen_h = 150;

var endTrackLen_e = 14;
var endTrackLen_h = 7;

var trackLen_e = 10;
var trackLen_h = 2.5;

var blankProb_e = 0.25;
var blankProb_h = 0.9;

var obsProb_e = 0.75;
var obsProb_h = 0.9;

var obsDist_e = 6;
var obsDist_h = 1.5;

function getRandPartDist(h){
	return irand(obsDist_e*2,obsDist_h*2)/2;
}

function addParts(h,pos,len)
{
	var p = pos+1;
	p += getRandPartDist(h);
	while(p<=(pos+len-1.5)){
		if(brand((1-h)*obsProb_e + h*obsProb_h)){
			levelData.add(tp,p);
		}
		p += getRandPartDist(h);
	}
}

function genLevel(l){
	srand(l);

	var h = l/hL;
	if(h > 1){
		h = 1;
	}

	var levelLen = Math.floor(irand(levelLen_e,levelLen_h*h));
	var startTrackLen = Math.floor(irand(endTrackLen_e,(endTrackLen_e-endTrackLen_h)*h+endTrackLen_h));
	var endTrackLen = Math.floor(irand(endTrackLen_e,(endTrackLen_e-endTrackLen_h)*h+endTrackLen_h));

	levelData = new Level();

	levelData.add(tts,startTrackLen);
	addParts(h,5,startTrackLen-5);

	var prevType = tts;

	while(levelData.length < levelLen-endTrackLen){
		if(brand((1-h)*blankProb_e + h*blankProb_h)){
			var len = 1;
			if(brand(h/2)){
				len = 1.25;
			}
			levelData.add(ttn,len);
			prevType = ttn;
		}

		var type = prevType;
		while(type == prevType){
			var p = rand()*(h/2+0.5);
			if(p<=0.25){
				type = tts;
			}else if(p<=0.5){
				type = ttr;
			}else if(p<=0.75){
				type = tti;
			}else{
				type = ttd;
			}
		}

		if((type == ttr)||(type == tti)){
			levelData.add(type,Math.max(Math.floor(irand(trackLen_e,(trackLen_e-trackLen_h)*h+trackLen_h)),10),1);
		}else{
			levelData.add(type,Math.floor(irand(trackLen_e,(trackLen_e-trackLen_h)*h+trackLen_h)),1);
		}

		var ctrack = levelData.tracks.length-1;
		addParts(h,levelData.tracks[ctrack].pos,levelData.tracks[ctrack].length);

		prevType = type;
	}

	if(brand((1-h)*blankProb_e + h*blankProb_h)){
		var len = 1;
		if(brand(h/2)){
			len = 1.25;
		}
		levelData.add(ttn,len);
	}

	levelData.add(tts,endTrackLen);
	var ctrack = levelData.tracks.length-1;
	addParts(h,levelData.tracks[ctrack].pos,endTrackLen-2.5);
}