var move = false;

function update(time)
{
	gameTime += time;

	switch(gameState)
	{
	case gameState_load:
		loadLevel(level);
		level++;
		gameState = gameState_levelNum;

		playerUp = 0;
		playerVel = 0;

		playerPos = new Vector(0,0,0);
		camPos = new Vector(0,1,-2);
		break;
	case gameState_levelNum:
		levelData.updateParts(time);
		if(gameTime > 1){
			if(spaceDown()){
				gameState = gameState_ready;
			}
		}
		break;
	case gameState_ready:
		levelData.updateParts(time);
		if(gameTime > 3*1.5)
			gameState = gameState_play;
		break;
	case gameState_play:
		playerUp += playerVel*time + gravity*time*time/2;
		playerVel += gravity*time;

		levelData.updateParts(time);

		if(playerPos.y >= -0.05){
			var x = playerPos.x;
			var interpolate = levelData.update(playerPos.z);

			if(levelData.playerHitPart()){
				playerCanJump = false;

				playerVel = 1;

				resetPos = levelData.findSafePos(playerPos.z-goBackLength);

				gameState = gameState_fall;
				playerUp = playerPos.y;

				lives--;
				if(lives==0){
					gameState = gameState_gameOver;
				}

				move = false;
			}

			if(playerCanJump && (playerUp == 0) && (spaceDown())){
				playerVel = 1;
				playerLeft = !playerLeft;
			}

			if(interpolate){
				if(playerCanJump || (playerUp>interpolateHeight)){
					playerPos.x = (x*Math.pow(interpolateSpeed,time))+(playerPos.x*(1-Math.pow(interpolateSpeed,time)));
				}else{
					playerPos.x = x;
				}
			}

			camPos.z += time;
		}else{
			resetPos = levelData.findSafePos(playerPos.z-goBackLength);

			gameState = gameState_fall;
			playerPos.y = playerUp;

			lives--;
			if(lives==0){
				gameState = gameState_gameOver;
			}

			move = true;
		}

		if(playerPos.z >= levelData.length+1){
			if(playerUp > 0.125){
				gameState = gameState_portal;
			}
		}

		playerPos.z += time;

		break;
	case gameState_fall:
		playerUp += playerVel*time + gravity*time*time/2;
		playerVel += gravity*time;

		levelData.updateParts(time);

		playerPos.y = playerUp;

		if(move){
			playerPos.z += time;
		}else{
			playerPos.z += time/4;
		}

		if(gameTime > 3*1.5){
			gameState = gameState_goBack;
		}

		break;
	case gameState_goBack:
		playerPos = levelData.getSafePos(resetPos,playerLeft);
		camPos.z = resetPos-2;

		playerVel = 0;
		playerUp = 0;

		levelData.updateParts(time);

		if(gameTime > 3){
			gameState = gameState_play;
		}

		break;
	case gameState_portal:
		levelData.updateParts(time);
		if(gameTime > 3){
			gameState = gameState_load;
		}
		break;
	case gameState_gameOver:
		playerUp += playerVel*time + gravity*time*time/2;
		playerVel += gravity*time;

		levelData.updateParts(time);

		playerPos.y = playerUp;

		if(move){
			playerPos.z += time;
		}else{
			playerPos.z += time/4;
		}

		if(gameTime > 1){
			if(spaceDown()){
				level = 0;
				lives = 5;
				gameState = gameState_load;
			}
		}
		break;
	default:
		done = true;
		break;
	}

	if(playerPos.z < 0){
		playerPos.z = 0;
		camPos.z = -2;
	}
}